package com.kob.backend.service.impl.pk;

import com.kob.backend.consumer.WebSocketServer;
import com.kob.backend.consumer.utils.Game;
import com.kob.backend.service.pk.ReceiveBotMoveService;
import org.springframework.stereotype.Service;

@Service
public class ReceiveBotMoveServiceImpl implements ReceiveBotMoveService {

    @Override
    public String receiveBotMove(Integer userId, Integer direction) {
        System.out.println("receive bot move: -> " + "userid: " + userId + "direction: " + direction);

        // 看看操作的 user 是否还存在
        if (WebSocketServer.users.get(userId) != null) {
            // 取出 game
            Game game = WebSocketServer.users.get(userId).game;
            // 判断 game 是否存在
            if (game != null) {
                // 将 Bot 的操作传给 game
                // 判断角色:如果是 A 角色,则将获取到的方向设置为 botA 的 nextStep 方向
                if (game.getPlayerA().getId().equals(userId)) {
                    game.setNextStepA(direction);
                } else if (game.getPlayerB().getId().equals(userId)) {
                    game.setNextStepB(direction);
                }
            }
        }


        return "receive bot move success";
    }
}
